//
// Frozen Anim Script by Evil Pumpkin
//
//


#include "../../../lib/std.mi"

#define ROTATION_LAYER_VAR myvol
#include "..\..\..\lib\rotationlayer.m"

Function StartAnimation(AnimatedLayer l, int start, int end, int speed);
Function updateVolume(int v);
Function initVolume();

Class AnimatedLayer AnimatedLayerHint;

Global Layout Main;
Global AnimatedLayerHint Play,Prev,Pause,Eject,Stop,Next;
Global Text info, Infotemp, Vol, sta;
Global Layer volumemark;
Global Int voling, x, y;
Global Map volumeMap;
Global Region volumeregion;
Global Slider HidVolume;

System.onScriptLoaded() {
  Main = getContainer("Main").getLayout("normal");
  Play = Main.getObject("anim.play");
  Prev = Main.getObject("anim.prev");
  Pause = Main.getObject("anim.Pause");
  Eject = Main.getObject("anim.Eject");
  Stop = Main.getObject("anim.Stop");
  Next = Main.getObject("anim.Next");
  Info = Main.getObject("songticker");
  Vol = Main.getObject("Vol");
  Sta = Main.getObject("Sta");
  HidVolume = Main.getObject("HiddenVolume");
  

  Infotemp = new text;

  Layout mainnormal = getContainer("Main").getLayout("Normal");

  volumeMap = new Map;
  volumeMap.loadMap("player.volume-map");
  voling = 0;

  volumemark = mainnormal.getObject("volumemark");

  volumeregion = new Region;
  volumeregion.loadFromBitmap("player.volume-region");
  volumemark.setRegion(volumeregion);

  _myvolInit(mainnormal, "volumemark");
  initVolume();
}

System.onplay(){Sta.settext("Playing!!");}
System.onStop(){sta.settext("Waiting...");}
System.onPause(){sta.settext("Paused...");}
System.onResume(){sta.settext("Playing!!");}

// Play

Play.onEnterArea() {
  StartAnimation(Play, getcurframe(), 9, 6);
}

Play.onLeftButtonUp(int x, int y) {
  gotoFrame(9);
  System.play();
  info.settext(infotemp.gettext());
}

Play.onLeftButtonDown(int x, int y) {
  gotoFrame(10);
  infotemp.settext(info.gettext());
  info.settext("Play");
}

Play.onLeaveArea() {
  StartAnimation(Play, getcurframe(), 0, 6);
}

// Prev

Prev.onEnterArea() {
  StartAnimation(Prev, getcurframe(), 9, 6);
}

Prev.onLeftButtonUp(int x, int y) {
  gotoFrame(9);
  Previous();
  info.settext(infotemp.gettext());
}

Prev.onLeftButtonDown(int x, int y) {
  gotoFrame(10);
  infotemp.settext(info.gettext());
  info.settext("Previous");
}

Prev.onLeaveArea() {
  StartAnimation(Prev, getcurframe(), 0, 6);
}

// Pause

Pause.onEnterArea() {
  StartAnimation(Pause, getcurframe(), 9, 6);
}

Pause.onLeftButtonUp(int x, int y) {
  gotoFrame(9);
  system.Pause();
  info.settext(infotemp.gettext());
}

Pause.onLeftButtonDown(int x, int y) {
  gotoFrame(10);
  infotemp.settext(info.gettext());
  info.settext("Pause");
}

Pause.onLeaveArea() {
  StartAnimation(Pause, getcurframe(), 0, 6);
}

// Eject

Eject.onEnterArea() {
  StartAnimation(Eject, getcurframe(), 9, 6);
}

Eject.onLeftButtonUp(int x, int y) {
  gotoFrame(9);
  Eject();
  info.settext(infotemp.gettext());
}

Eject.onLeftButtonDown(int x, int y) {
  gotoFrame(10);
  infotemp.settext(info.gettext());
  info.settext("Open");
}

Eject.onLeaveArea() {
  StartAnimation(Eject, getcurframe(), 0, 6);
}

// Stop

Stop.onEnterArea() {
  StartAnimation(Stop, getcurframe(), 9, 6);
}

Stop.onLeftButtonUp(int x, int y) {
  gotoFrame(9);
  system.Stop();
  info.settext(infotemp.gettext());
}

Stop.onLeftButtonDown(int x, int y) {
  gotoFrame(10);
  infotemp.settext(info.gettext());
  info.settext("Stop");
}

Stop.onLeaveArea() {
  StartAnimation(Stop, getcurframe(), 0, 6);
}

// Next

Next.onEnterArea() {
  StartAnimation(Next, getcurframe(), 9, 6);
}

Next.onLeftButtonUp(int x, int y) {
  gotoFrame(9);
  Next();
  info.settext(infotemp.gettext());
}

Next.onLeftButtonDown(int x, int y) {
  gotoFrame(10);
}

Next.onLeaveArea() {
  StartAnimation(Next, getcurframe(), 0, 6);
}




// Functions

StartAnimation(AnimatedLayer l, int start, int end, int speed) {
  l.stop();
  l.setStartFrame(start);
  l.setEndFrame(end);
  l.setSpeed(speed);
  l.setAutoReplay(0);
  l.play();  
}

// Volume

volumemark.onLeftButtonDown(int x, int y) {
  voling = 1;
}

volumemark.onLeftButtonUp(int x, int y) {
  if (voling) {
    x = x - volumemark.getLeft();
    y = y - volumemark.getTop();

    if (volumeMap.inRegion(x, y)) { 
      float v = volumeMap.getValue(x, y);
      updateVolume(v); 
    }
     voling = 0;
  }
}

// Initializes volume
initVolume() {
  int u, f;
  u = System.getVolume();
  f = (u / 255) * 280;

  _myvolRotateDegree(-f);
  Vol.settext("VOLUME " + integertostring(f/280*100) + "%");
}


// Reads mouse drag on volume knob
volumemark.onMouseMove(int x, int y) {
  if (voling) {
    x = x - volumemark.getLeft();
    y = y - volumemark.getTop();

    if (volumeMap.inRegion(x, y)) { 
      float v = volumeMap.getValue(x, y);
      updateVolume(v);
    }
  }
}

// Updates Volume after drag|click
updateVolume(int v) {
  system.setvolume(v);
  v = (v / 255) * 280;
  _myvolRotateDegree(-v);
  if (v < 280){
  vol.settext("VOLUME  " + System.integerToString(v/280*100) + "%");}
  else {
  vol.settext("VOLUME " + System.integerToString(v/280*100) + "%");};
}

// Used to read mouse wheel

HidVolume.OnPostedPosition(int p){
 p = (p / 255) * 280;
 _myvolRotateDegree(-p); 
  if (p < 280){
  vol.settext("VOLUME  " + System.integerToString(p/280*100) + "%");}
  else {
  vol.settext("VOLUME " + System.integerToString(p/280*100) + "%");};
}